// 
// - Auteur                    : Arthur Cayuso ISC-1ere / HEPIA
// - Date                      : 28 juin 2021
// - Nom                       : TP Ligne de champs électrique
// - But                       : Simuler un phénomème physique vu en cours a l'aide du langage C et visualiser les lignes de champs électriques générées par N partciules.
// - Résultat                  : Visualition graphique de plusieurs lignes de champs provenamant de deux charges(Une Positive & une Negative)
/// Uses the SDL2 library on gfx.
#include <stdio.h>
#include <math.h>
#include <stdlib.h> // pour acceder au random
#include <time.h>   // pour acceder au time machine
#include <stdbool.h> // librairie C pour les boolean
#include "gfx.h"
#include "vector.h"
#include "particule.h"
#include "utils.h"

#define DIV_WINDOW 2
#define EC -1.602e-19
#define NUM_CHAMPS 100
#define MAX_PROXIMITY 10
#define NUM_CHARGE 3

int main()
{
    srand(time(0));      								// (RANDOM)->Initialisation de la graine avec le temps
	//Remarque sur la taille des pixels : en augmentant le diviseur le canvas devient plus petit
	// passé en full screen -> les pixels sont plus gros = gros diviseur = gros pixels
	int div = DIV_WINDOW; // le diviseur
	int width = 1920/div, height = 1080/div;// taille du canvas

  //tableau qui contient toutes les charges
  charge_t charges[NUM_CHARGE];

  charges[0].q = 1/ +EC; // Plus la charge est grande, plus d'influance 
  charges[0].pos.x = 0.4;
  charges[0].pos.y = 0.5;

  charges[1].q = 1/ -EC;
  charges[1].pos.x = 0.55;
  charges[1].pos.y = 0.5;

  charges[2].q = 1.0 / +EC;
  charges[2].pos.x = rand_one();
  charges[2].pos.y = rand_one();

  // charges[3].q = 1.0 / -EC;
  // charges[3].pos.x = rand_one();
  // charges[3].pos.y = rand_one();

  // charges[4].q = 1.0 / -EC;
  // charges[4].pos.x = rand_one();
  // charges[4].pos.y = rand_one();

  printf("charge1 {.pos.x = %f, .pos.y = %f};\r\n",charges[0].pos.x, charges[0].pos.y);
  printf("charge2 {.pos.x = %f, .pos.y = %f};\r\n",charges[1].pos.x, charges[1].pos.y);


	struct gfx_context_t *ctxt = gfx_create("TP - Physique 1er annee / Ligne de champs electrique", width, height);  // titre du canvas

  draw_charges(ctxt, charges, NUM_CHARGE, 0.0, 1.0, 0.0, 1.0, NUM_CHAMPS, MAX_PROXIMITY);

	if (!ctxt)
	{																						// try catch erreurs
		fprintf(stderr, "Graphics initialization failed!\n");
		return EXIT_FAILURE;
	}


	while (gfx_keypressed() != SDLK_ESCAPE) // touche escape pour quitter le canvas
	{
		gfx_present(ctxt);						 // affiche le contexte
	}

	gfx_destroy(ctxt);							 // delete le contexte
	return EXIT_SUCCESS;
}