#include "vector.h"

//____________________________________
// PARTIE VECTEURS

vec vec_create(double x, double y) {
    vec v = {.x = x, .y = y};
    return v;
}

void vec_print(vec v, char *name) {
    printf("%s = (%f, %f)\n", name, v.x, v.y);
}

vec vec_add(vec lhs, vec rhs) {
    return vec_create(lhs.x + rhs.x, lhs.y + rhs.y);
}

vec vec_div(vec lhs, double alpha) {
    return vec_create(lhs.x/alpha, lhs.y/alpha);
}

vec vec_sub(vec lhs, vec rhs) {
    return vec_create(lhs.x - rhs.x, lhs.y - rhs.y);
}



vec vec_mul(vec v, double alpha) {
    return vec_create(alpha * v.x, alpha * v.y);
}

double vec_scalar_product(vec lhs, vec rhs) {
    return lhs.x * rhs.x + lhs.y * rhs.y;
}

double vec_norm(vec v)
{
    return sqrt((v.x*v.x)+(v.y*v.y));
}

double sqr(double a) {
    return a*a;
}

double vec_distance(vec v1, vec v2)
{
  return sqrt(sqr(v2.y - v1.y) + sqr(v2.x - v1.x));
}
