#ifndef VECTOR_H
#define VECTOR_H

#include <stdio.h>
#include <math.h>
#include <stdlib.h> // pour acceder au random
#include <time.h>   // pour acceder au time machine
#include <stdbool.h> // librairie C pour les boolean


typedef struct _vec {
    double x, y;
} vec;

vec vec_create(double x, double y);
void vec_print(vec v, char *name);
vec vec_add(vec lhs, vec rhs);
vec vec_sub(vec lhs, vec rhs);
vec vec_mul(vec v, double alpha);
vec vec_div(vec lhs, double alpha);
double vec_scalar_product(vec lhs, vec rhs);
double vec_norm_sqr(vec v);
double vec_norm(vec v);
double vec_distance(vec v1, vec v2);
double sqr(double a);

#endif
